#AI_Battle v3
#By EdT with help from s10k
#Borrowed/modified code from Oni Zen Gardena and OTA.

var int watchflag=0;
var int fightflag=0;
var int changeflag=0;
var int flagnum=0;
var int faceflag=0;
var int aicount=0;
var int setfight=0;
var int synd_loss=0;
var int tctf_loss=0;
var int selectfriend=0;
var int friendcount=0;
var int selectenemy=0;
var int enemycount=0;
var int weaponoption=0;
var int weaponflag=0;
var int arenaoption=0;
var int rand_weapon=0;
var int tctfflag=2;
var int syndflag=5;
var int friendflag=0;
var int enemyflag=6;
var int areaflag=0;
var int wid=0;
var int neverdieflag=0;
var int bossflag=0;
var int count=0;
var int aiboss=0;
var int amt=0;
var int otaflag=0;
var int daodanflag=0;
var int spawn_id=0;
var int rand_flag1=0;
var int rand_flag2=0;
var int rand_dead=0;
var int arena_scoring=1;
var int arena_players=1;
var int arena_limit= 0;
var int arena_time= 0;
var int rand_music=0;
var string powerup;
var string weapon_name;
var string char;
var string char1;
var string char2;
var string char3;
var string char4;
var string char5;
var string char6;
var string char7;
var string char8;
var string class;
var string now_playing; 
var string next_tune;

func void main (void) {

	gl_fog_blue=.15
	gl_fog_red=.15
	gl_fog_green=.15
	gl_fog_start=.99
	gs_farclipplane_set 10000
		
	ui_suppress_prompt = 1
	gs_show_ui = 0
		
	env_show 2010 0
	console_deactivate 11
	
	ai2_ignore_player=1
	ai2_allpassive 1
		
	chr_teleport 0 0
	chr_facetoflag 0 0
		
	chr_mini_me = 1
	chr_mini_me_amount = .1
	chr_unstoppable 0 1
	chr_invincible 0 1
	give_powerup(invis, -1)
	
	
	fork randgen();
	
	options();
	
}

#### Battle Modes ####


func void watch(void){
	aicount=0;
	dmsg("  ");
	dmsg("  ");
	dmsg("  ");
	dmsg("Select Blue Team members.");
	watchflag = 1;
	if (areaflag eq 1){
	chr_teleport 0 100
	chr_facetoflag 0 100
	chr_givepowerup 0 invis -1
	}
	if (areaflag eq 2){
	chr_teleport 0 206
	chr_facetoflag 0 206
	chr_givepowerup 0 invis -1
	}
	if (areaflag eq 3){
	chr_teleport 0 310
	chr_facetoflag 0 310
	chr_givepowerup 0 invis -1
	}
}

func void watchbattle(void){
	if(selectenemy eq 0){
		selectfriend=1;
		if(otaflag eq 1){
			AddPlayer(char, TCTF);
		}
		
		if(otaflag eq 0){
			if (areaflag eq 0){
				tctfflag = tctfflag + 1
				AddAI(char, TCTF, tctfflag, 3);
				if (tctfflag eq 5){
					tctfflag=3;
				}
			}
			if (areaflag eq 1){
				tctfflag = tctfflag + 1
				AddAI(char, TCTF, tctfflag, 3);
				if (tctfflag eq 105){
					tctfflag=103;
				}
			}
			if (areaflag eq 2){
				tctfflag = tctfflag + 1
				AddAI(char, TCTF, tctfflag, 200);
				if (tctfflag eq 202){
					tctfflag=200;
				}
			}
		}

		#dmsg("  ");
		#dmsg("  ");
		dmsg("Select more members for your team or");	
		dmsg("Type [b.next] to select Red Team members");
	}
	if(selectenemy eq 1){
	
		if(otaflag eq 1){
				AddPlayer(char, Syndicate);
		}
	
		if(otaflag eq 0){
			if (areaflag eq 0){
				syndflag = syndflag + 1
				AddAI(char, Syndicate, syndflag, 6);
				if (syndflag eq 8){
					syndflag=6;
				}
			}
			if (areaflag eq 1){
				syndflag = syndflag + 1
				AddAI(char, Syndicate, syndflag, 6);
				if (syndflag eq 108){
					syndflag=106;
				}
			}
			if (areaflag eq 2){
				syndflag = syndflag + 1
				AddAI(char, Syndicate, syndflag, 203);
				if (syndflag eq 205){
				syndflag=203;
				}
			}
		}
		dmsg("  ");
		dmsg("  ");
		dmsg("Select more members or")	
		dmsg("Type [g.go] to start battle");
	}
}


func void fight(void){
	if (areaflag eq 1){
		chr_teleport 0 100
		chr_facetoflag 0 100
	}
	if (areaflag eq 2){
		chr_teleport 0 200
		chr_facetoflag 0 200
	}
	if (areaflag eq 3){
		chr_teleport 0 300
		chr_facetoflag 0 300
	}
	if(otaflag eq 1){
		fork respawnplayer(char_0, TCTF, 0);
	}
	chr_mini_me = 0;
	ai2_ignore_player=0
	chr_unstoppable 0 0
	chr_invincible 0 0
	chr_inv_reset 0
	chr_changeteam 0 TCTF
	gs_show_ui = 1;
	fightflag = 1;
	dmsg("  ");
	dmsg("  ");
	dmsg("Select your team")	
	dmsg("Type [b.next] to select the Red Team members");
}

func void fightbattle(void){
	if(selectenemy eq 0){
		selectfriend=1;
		if(otaflag eq 1){
				AddPlayer(char, TCTF);
			}
		
		if(otaflag eq 0){	
			if (areaflag eq 0){
				friendflag = friendflag + 1
				AddAI(char, TCTF, friendflag, 0);
				if (friendflag eq 2){
					friendflag=0;
				}
			}
			if (areaflag eq 1){
				friendflag = friendflag + 1
				AddAI(char, TCTF, friendflag, 0);
				if (friendflag eq 102){
				friendflag=100;
				}
			}
			if (areaflag eq 2){
				friendflag = friendflag + 1
			AddAI(char, TCTF, friendflag, 200);
				if (friendflag eq 202){
					friendflag=200;
				}
			}
		}
			dmsg("Select more members for your team or")	
		dmsg("Type [b.next] to select the Red Team members");
	}
	if(selectenemy eq 1){
		if(otaflag eq 1){
				AddPlayer(char, Syndicate);
			}
		
		if(otaflag eq 0){	
			if (areaflag eq 0){
				enemyflag = enemyflag + 3
				AddAI(char, Syndicate, enemyflag, 9);
				if (enemyflag >= 6){
					enemyflag=0;
				}
			}
	
			if (areaflag eq 1){
				enemyflag = enemyflag + 3
				AddAI(char, Syndicate, enemyflag, 9);
				if (enemyflag >= 106){
					enemyflag=100;
				}
			}
			if (areaflag eq 2){
				enemyflag = enemyflag + 1
				AddAI(char, Syndicate, enemyflag, 203);
				if (enemyflag = 205){
					enemyflag=202;
				}
			}
		}
		dmsg("  ");
		dmsg("  ");
		dmsg("Select more enemies or")	
		dmsg("Type [g.go] to start battle");
	
 	}
}

func void boss(void){
	bossflag = 1;
	ai2_allpassive 0
	chr_teleport 0 300
	chr_facetoflag 0 300
	chr_mini_me = 0;
	gs_show_ui = 1;
	ai2_ignore_player=0
	chr_unstoppable 0 0
	chr_invincible 0 0
	chr_inv_reset 0
	dmsg("  ");
	dmsg("Can you show the world, you are the Boss?");
	dmsg("  ");
	dmsg("Select up to 8 enemies to run the gauntlet.")	
	
}

func void bossai(void){
	bossflag = 1;
	aiboss=1;
	ai2_allpassive 0
	dmsg("  ");
	dmsg("  ");
	dmsg("  ");
	dmsg("Choose the Boss AI");
	chr_teleport 0 309 
	chr_facetoflag 0 309
	chr_givepowerup 0 invis -1
	}

func void setupboss(void){
	if(aiboss eq 1){
		spawnAI(char, TCTF);
	}
	else{
	spawnAI(char, Switzerland);
	dmsg("  ");
	dmsg("  ");
	dmsg("Select more enemies or")	
	dmsg("Type [g.go] to start battle");
	}
}

func void gauntlet(void){
	count = count + 1;
	
	if(count <= aicount){
	if(count eq 1){
		chr_changeteam(char1, Syndicate);
		ai2_passive(char1,0);
		if(aiboss eq 0) ai2_attack(char1,0);
		if(aiboss eq 2) ai2_attack(char1,1);
		chr_unstoppable(char1,0)
		chr_wait_health(char1,0);
	}
	if(count eq 2){
		chr_changeteam(char2, Syndicate);
		ai2_passive(char2,0);
		if(aiboss eq 0) ai2_attack(char2,0);
		if(aiboss eq 2) ai2_attack(char2,1);
		chr_unstoppable(char2,0)
		chr_wait_health(char2,0);
	}
	if(count eq 3){
		chr_changeteam(char3, Syndicate);
		ai2_passive(char3,0);
		if(aiboss eq 0) ai2_attack(char3,0);
		if(aiboss eq 2) ai2_attack(char3,1);
		chr_unstoppable(char3,0)
		chr_wait_health(char3,0);
	}
	if(count eq 4){
		chr_changeteam(char4, Syndicate);
		ai2_passive(char4,0);
		if(aiboss eq 0) ai2_attack(char4,0);
		if(aiboss eq 2) ai2_attack(char4,1);
		chr_unstoppable(char4,0)
		chr_wait_health(char4,0);
	}
	if(count eq 5){
		chr_changeteam(char5, Syndicate);
		ai2_passive(char5,0);
		if(aiboss eq 0) ai2_attack(char5,0);
		if(aiboss eq 2) ai2_attack(char5,1);
		chr_unstoppable(char5,0)
		chr_wait_health(char5,0);
	}
	if(count eq 6){
		chr_changeteam(char6, Syndicate);
		ai2_passive(char6,0);
		if(aiboss eq 0) ai2_attack(char6,0);
		if(aiboss eq 2) ai2_attack(char6,1);
		chr_unstoppable(char6,0)
		chr_wait_health(char6,0);
	}
	if(count eq 7){
		chr_changeteam(char7, Syndicate);
		ai2_passive(char7,0);
		if(aiboss eq 0) ai2_attack(char7,0);
		if(aiboss eq 2) ai2_attack(char7,1);
		chr_unstoppable(char7,0)
		chr_wait_health(char7,0);
	}
	if(count eq 8){
		chr_changeteam(char8, Syndicate);
		ai2_passive(char8,0);
		if(aiboss eq 0) ai2_attack(char8,0);
		if(aiboss eq 2) ai2_attack(char8,1);
		chr_unstoppable(char8,0)
		chr_wait_health(char8,0);
	}
	fork gauntlet
	}
	
	if(count > aicount){
	dmsg("  ");
	dmsg("  ");
	dmsg("  ");
	dmsg("You have run the gauntlet and you are the Boss!")	
	sleep 300
	reset
	}
	
}

func void ota(int limitx, int areax, int widx){
	dmsg("  ")
	dmsg("  ")
	dmsg("  ")
	dmsg("  ")
	areaflag = areax;
	arena_limit = limitx;
	weaponoption = widx;
	otaflag=1;
	trigvolume_enable cleararea 0
	gs_show_ui = 1;
	ArenaScoreInfo();
	
	if (areax eq 0){
		dmsg("[b.Cage area selected]")
	}
	if (areax eq 1){ 
		dmsg("[b.Danger area selected]")
	}
	if (areax eq 2){ 
		dmsg("[b.Open area selected]")
	}
	if (areax eq 3){ 
		dmsg("[b.Gauntlet area selected]")
	}
	ArenaScoreInfo();
	if(weaponoption eq 1){
	dmsg("Random weapons on")
	}
	dmsg("Select Battle mode: AI - [y.watch] Player - [y.fight]")
}

#### Character Functions ####

func void add(void){	
	if(changeflag eq 1){
		fork switchclass();
		
	}
	else if(watchflag eq 1){
			watchbattle();
			
		}
	else if(fightflag eq 1){
			fightbattle();
			
		}
	else if(bossflag eq 1){
			setupboss();
		}	
}


func void AddAI(string ai_name, string ai_team, int flagnum, int faceflag) {

	ai2_spawn(ai_name); 
	chr_changeteam(ai_name, ai_team);
	chr_set_health(ai_name, 200);
	if (daodanflag eq 1){
		chr_super(ai_name, 1);
	}
	chr_teleport(ai_name, flagnum);
	chr_facetoflag(ai_name, faceflag);
	ai2_setalert(ai_name, high);
	aicount = aicount+1
	
	if (selectfriend eq 1){
		friendcount = friendcount +1
		PrintScore(friendcount);
		#dmsg("# of Blue Team members")
	}
	if (selectenemy eq 1){
		enemycount = enemycount +1
		PrintScore(enemycount);
		#dmsg("# of Red Team members")
	}
	if (weaponflag eq 1){
		fork weaponoptions
		chr_giveweapon(ai_name, weapon_name);
		chr_givepowerup(ai_name, cell, 10);
		chr_givepowerup(ai_name, ammo, 10);
		if(ai_name eq "irondemon"){ iron(); }
		if(ai_name eq sniper){ snip();  }
		if(ai_name eq guarddog1){ gd1w();  } 
		if(ai_name eq guarddog2){ gd2w();  } 
		if(ai_name eq guarddog3){ gd3w();  }
		if(ai_name eq guarddog4){ gd4w();  } 
		if(ai_name eq sentry){ sdw();  } 
		if(ai_name eq rayman){ onlyfists();  } 
		if(ai_name eq hammer){ onlyfists();  } 
		if(ai_name eq jestergiant){ onlyfists();  } 
		if(ai_name eq mutantmuro){ onlyfists();  }
		
	}
	if (neverdieflag eq 1){
			chr_invincible(ai_name, 1)
		}
	if (otaflag eq 1){
			fork respawnplayer(ai_name, ai_team, aicount)
		}
		else {
			fork wait_ai_die(ai_name, ai_team, aicount)
	}
	
}

func void spawnAI(string ai_name, string ai_team) {
	ai2_spawn(ai_name); 
	chr_changeteam(ai_name, ai_team);
	chr_set_health(ai_name, 200);
	if (daodanflag eq 1){
		chr_super(ai_name, 1);
	}
	
	if(aiboss eq 1){
		chr_teleport(ai_name, 300);
		chr_facetoflag(ai_name, 300);
		chr_set_health(ai_name, 200);
		dmsg("  ");
		dmsg("  ");
		dmsg("Select up to 8 enemies to run the gauntlet.")
		aiboss = 2;
		chr_wait_health(ai_name, 0);
		dmsg(" ");
		dmsg("Boss you are not!");
		sleep 300
		reset
	}
	
	else{
	aicount = aicount+1
	if (aicount < 9){
	chr_unstoppable(ai_name,1);
	ai2_passive(ai_name,1);
	flagnum = 300 + aicount
	chr_teleport(ai_name, flagnum);
	chr_facetoflag(ai_name, flagnum);
	
	if (aicount eq 1){
		char1 = ai_name
	}
	if (aicount eq 2){
		char2 = ai_name;
		chr_facetoflag(0, 304);
	}
	if (aicount eq 3){
		char3 = ai_name;
		chr_facetoflag(0, 301);
	}	
	if (aicount eq 4){
		char4 = ai_name;
		chr_facetoflag(0, 302);
		}	
	if (aicount eq 5){
		char5 = ai_name;
		chr_facetoflag(0, 306);
	}	
	if (aicount eq 6){
		char6 = ai_name;
		chr_facetoflag(0, 305);
	}	
	if (aicount eq 7){
		char7 = ai_name;
		chr_facetoflag(0, 308);
	}	
	if (aicount eq 8){
		char8 = ai_name;
		chr_facetoflag(0, 307);
		dmsg("You have reached the limit, time to battle")
		go();
	}	
	
	}
	
	}

}


func void wait_ai_die(string ai_name, string ai_team, int ai_id){
	chr_wait_health(ai_name,1);
	chr_delete(ai_name);
	dmsg(ai_name);
	dmsg("was defeated!");
	sleep 120;
		
	if(ai_team eq Syndicate){
		synd_loss=synd_loss+1
	}
	if(ai_team eq TCTF){
		tctf_loss=tctf_loss+1
	}
	
	
	if(watchflag eq 1){
		if(tctf_loss eq friendcount){
			dmsg("  ");
			dmsg("  ");
			dmsg("  ");
			dmsg("[y.Red Team won!]")
			sleep 300;
			reset
		}
		if(synd_loss eq enemycount){
			dmsg("  ");
			dmsg("  ");
			dmsg("  ");
			dmsg("[y.Blue Team won!]")
			sleep 300;
			reset
		}
	}
	
	if(fightflag eq 1){
		if(synd_loss eq enemycount){
			sleep 120;
			dmsg("  ");
			dmsg("  ");
			dmsg("  ");
			dmsg("[y.Your team is victorious!]")
			sleep 300;
			reset
		}
	}				
}


#### Game Functions ####

func void go(void){
	if(otaflag eq 1){
	ai2_allpassive 0
	ArenaResetScore();
	RandMusic();
	fork ArenaMusic();
	}
	if (bossflag eq 0){
		ai2_allpassive 0
		dmsg("  ");
		dmsg("  ");
		dmsg("  ");
 		dmsg("Let the battle begin!");
 		
	}
	if (bossflag eq 1){
		chr_facetoflag 0 300
		gauntlet(); 
	}
	if (weaponoption ne 0 and fightflag eq 1){
		fork weaponoptions
		chr_giveweapon(0, weapon_name);
		chr_givepowerup(0, cell, 10);
		chr_givepowerup(0, ammo, 10);
	} 
	if (daodanflag eq 1 and fightflag eq 1){
		chr_super(0, 1);
	}
	
}

func void next(void){
	selectfriend=0;
	selectenemy=1;
	if (areaflag eq 2){
		chr_facetoflag 0 201
		}
	dmsg("  ");
	dmsg("  ");
	dmsg("  ");
	dmsg("Select the Red Team members.");
}


func void reset(void){
	ai2_allpassive 1
	dmsg("Resetting the game in")
	dmsg("3")
	sleep 60
	dmsg("2")
	sleep 60
	dmsg("1")
	sleep 60
	lose
}


##### Options ####

func void change(void){
	chr_mini_me = 0;
	setfight=1
	changeflag=1
	dmsg("  ");
	dmsg("  ");
	dmsg("  ");
	dmsg("Select character class")
}


func void switchclass(void){
	changeflag = 0;
	chr_set_class(0,class)
	dmsg("  ");
	dmsg("Select Battle Mode")
	dmsg("AI Only - watch")
	dmsg("Player - fight")
}	


func void focus(int idx){
	chr_focus(idx)
}

func void weapon(int idx){
	dmsg("[b.Weapons option on]")
	weaponflag = 1;
	weaponoption = idx;
}

func void area(int idx){
	if (idx eq 1){
		dmsg("[b.Danger area selected]")
		areaflag = 1;
		tctfflag = 102;
		syndflag = 105;
		friendflag = 100;
		enemyflag = 106;
		gs_show_shadows = 0;
	}
	if (idx eq 2){
		dmsg("[b.Open area selected]")
		areaflag = 2;
		tctfflag = 199;
		syndflag = 202;
		friendflag = 200;
		enemyflag = 202;
	}
}

func void daodan(void){
	dmsg("[b.Daodan option on]")
	daodanflag = 1;
}

func void liveforever(void){
	neverdieflag = 1;
	dmsg("[r.No one will die in battle]")
	dmsg("Type [y.lose] to restart")
}

func void giveweapon(string ai_name, int widx){
	rand_weapon =  widx;
	weaponoption = 1;
	fork weaponoptions
	chr_giveweapon(ai_name, weapon_name);
	weaponoption = 0;
	dmsg(weapon_name)
	dmsg("given to AI")
	}
	
func void givepowerup(string ai_name, string powerx, int amtx){
	powerup = powerx;
	amt = amtx;
	chr_givepowerup(ai_name, powerup, amt)
	dmsg(powerup)
	dmsg("given to AI")
}



#### OTA Functions ####

func void AddPlayer(string ai_name, string ai_team) {
	dmsg(ai_name); dmsg("entered the arena");
	ai2_spawn(ai_name); chr_changeteam(ai_name, ai_team);
	ai2_neutralbehavior(ai_name, none)
#	ai2_passive(ai_name, 0); chr_neutral(ai_name, 0);
#	chr_freeze(ai_name, 0); ai2_active(ai_name);
#	chr_lock_active(ai_name);
	ai2_noncombatant(ai_name, 0); chr_unkillable(ai_name, 1);
	fork respawnplayer(ai_name, ai_team, arena_players);
	arena_players= arena_players + 1;
}

func void respawnplayer(string ai_name, string ai_team, int ai_id) {
	if(chr_is_player(ai_name)) RandMusic();
	chr_invincible(ai_name, 1); chr_set_health(ai_name, 200);
	fork SendToRandFlag(ai_id, ai_name, ai_team);
	chr_inv_reset(ai_name);
	fork GiveRandWeapon(ai_name);
	#fork GiveRandPowerups(ai_name);
	#ai2_idle(ai_name); ai2_setjobstate(ai_name);
	sleep 30; chr_invincible(ai_name, 0);
	ai2_setalert(ai_name, high); 

	chr_wait_health(ai_name, 1);
	if(arena_scoring) fork Death(ai_team, ai_name);
	chr_inv_reset(ai_name); chr_givepowerup(ai_name, invis, -1);
	chr_changeteam(ai_name, Switzerland);
	sleep 60; chr_changeteam(ai_name, ai_team);
	fork respawnplayer(ai_name, ai_team, ai_id);
}

func void randgen(void) {
	rand_weapon= rand_weapon + 1; if(rand_weapon > 11) rand_weapon= 0
	rand_flag1= rand_flag1 + 1; if(rand_flag1 > 6) rand_flag1= 0;
	rand_flag2= rand_flag2 + 1; if(rand_flag2 > 6) rand_flag2= 0;
	rand_dead= rand_dead + 1; if(rand_dead > 22) rand_dead= 0;
	rand_music= rand_music + 1; if(rand_music > 12) rand_music= 0;
	sleep 1; fork randgen();
	
}



func void SendToRandFlag(int ai_id, string ai_name, string ai_team) {

# Cage
	if(areaflag eq 0) {
		if(ai_team eq TCTF) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 3); chr_facetoflag(ai_name, 3);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 4); chr_facetoflag(ai_name, 4);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 5); chr_facetoflag(ai_name, 5);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name, 10); chr_facetoflag(ai_name, 10);}
			if(rand_flag1 eq 4)
				{chr_teleport(ai_name, 11); chr_facetoflag(ai_name, 11);}
			if(rand_flag1 eq 5)
				{chr_teleport(ai_name, 12); chr_facetoflag(ai_name, 12);}
			if(rand_flag1 eq 6)
				{chr_teleport(ai_name, 13); chr_facetoflag(ai_name, 13);}
			if(rand_flag1 > 6)
				{chr_teleport(ai_name, 12); chr_facetoflag(ai_name, 12);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq 0)
				{chr_teleport(ai_name, 6); chr_facetoflag(ai_name, 6);}
			if(rand_flag2 eq 1)
				{chr_teleport(ai_name, 7); chr_facetoflag(ai_name, 7);}
			if(rand_flag2 eq 2)
				{chr_teleport(ai_name, 8); chr_facetoflag(ai_name, 8);}
			if(rand_flag2 eq 3)
				{chr_teleport(ai_name, 14); chr_facetoflag(ai_name, 14);}
			if(rand_flag2 eq 4)
				{chr_teleport(ai_name, 15); chr_facetoflag(ai_name, 15);}
			if(rand_flag2 eq 5)
				{chr_teleport(ai_name, 16); chr_facetoflag(ai_name, 16);}
			if(rand_flag2 eq 6)
				{chr_teleport(ai_name, 17); chr_facetoflag(ai_name, 17);}
			if(rand_flag2 > 6)
				{chr_teleport(ai_name, 14); chr_facetoflag(ai_name, 14);}
		}
	}
# Danger
	if(areaflag eq 1) {
		if(ai_team eq TCTF) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 103); chr_facetoflag(ai_name, 103);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 104); chr_facetoflag(ai_name, 104);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 105); chr_facetoflag(ai_name, 105);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name, 110); chr_facetoflag(ai_name, 10);}
			if(rand_flag1 eq 4)
				{chr_teleport(ai_name, 111); chr_facetoflag(ai_name, 111);}
			if(rand_flag1 eq 5)
				{chr_teleport(ai_name, 112); chr_facetoflag(ai_name, 112);}
			if(rand_flag1 eq 6)
				{chr_teleport(ai_name, 113); chr_facetoflag(ai_name, 113);}
			if(rand_flag1 > 6)
				{chr_teleport(ai_name, 112); chr_facetoflag(ai_name, 112);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag2 eq  0)
				{chr_teleport(ai_name, 106); chr_facetoflag(ai_name, 106);}
			if(rand_flag2 eq 1)
				{chr_teleport(ai_name, 107); chr_facetoflag(ai_name, 107);}
			if(rand_flag2 eq 2)
				{chr_teleport(ai_name, 108); chr_facetoflag(ai_name, 108);}
			if(rand_flag2 eq 3)
				{chr_teleport(ai_name, 114); chr_facetoflag(ai_name, 114);}
			if(rand_flag2 eq 4)
				{chr_teleport(ai_name, 115); chr_facetoflag(ai_name, 115);}
			if(rand_flag2 eq 5)
				{chr_teleport(ai_name, 116); chr_facetoflag(ai_name, 116);}
			if(rand_flag2 eq 6)
				{chr_teleport(ai_name, 117); chr_facetoflag(ai_name, 117);}
			if(rand_flag2 > 6)
				{chr_teleport(ai_name, 114); chr_facetoflag(ai_name, 114);}
		}
	}
	
	
# Open
	if(areaflag eq 2) {
		if(ai_team eq TCTF) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 200); chr_facetoflag(ai_name, 200);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 201); chr_facetoflag(ai_name, 201);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 202); chr_facetoflag(ai_name, 202);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name, 207); chr_facetoflag(ai_name, 207);}
			if(rand_flag1 eq 4)
				{chr_teleport(ai_name, 208); chr_facetoflag(ai_name, 208);}
			if(rand_flag1 eq 5)
				{chr_teleport(ai_name, 209); chr_facetoflag(ai_name, 209);}
			if(rand_flag1 eq 6)
				{chr_teleport(ai_name, 210); chr_facetoflag(ai_name, 210);}
			if(rand_flag1 > 6)
				{chr_teleport(ai_name, 207); chr_facetoflag(ai_name, 207);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 203); chr_facetoflag(ai_name, 203);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 204); chr_facetoflag(ai_name, 204);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 205); chr_facetoflag(ai_name, 205);}
			if(rand_flag1 eq 3)
				{chr_teleport(ai_name, 211); chr_facetoflag(ai_name, 211);}
			if(rand_flag1 eq 4)
				{chr_teleport(ai_name, 212); chr_facetoflag(ai_name, 212);}
			if(rand_flag1 eq 5)
				{chr_teleport(ai_name, 213); chr_facetoflag(ai_name, 213);}
			if(rand_flag1 eq 6)
				{chr_teleport(ai_name, 214); chr_facetoflag(ai_name, 214);}
			if(rand_flag1 > 6)
				{chr_teleport(ai_name, 205); chr_facetoflag(ai_name, 205);}
		}
	}
	
# Gauntlet
	if(areaflag eq 3) {
		if(ai_team eq TCTF) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 306); chr_facetoflag(ai_name, 306);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 302); chr_facetoflag(ai_name, 302);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 303); chr_facetoflag(ai_name, 303);}
			if(rand_flag1 > 2)
				{chr_teleport(ai_name, 307); chr_facetoflag(ai_name, 307);}
		}
		if(ai_team eq Syndicate) {
			if(rand_flag1 eq 0)
				{chr_teleport(ai_name, 304); chr_facetoflag(ai_name, 304);}
			if(rand_flag1 eq 1)
				{chr_teleport(ai_name, 305); chr_facetoflag(ai_name, 305);}
			if(rand_flag1 eq 2)
				{chr_teleport(ai_name, 301); chr_facetoflag(ai_name, 301);}
			if(rand_flag1 > 2)
				{chr_teleport(ai_name, 308); chr_facetoflag(ai_name, 308);}
		}
	}

	chr_animate(ai_name, KONCOMsuper_kick);
}

func void ArenaMusic(void) {
	if(next_tune ne now_playing) {
		sound_music_stop(now_playing); now_playing= next_tune; 
		sleep 400; sound_music_start(now_playing);
	}
	sleep 4000; fork ArenaMusic();
}

func void RandMusic(void) {
	if(rand_music eq 0) next_tune= mus_fitec_hd;
	if(rand_music eq 1) next_tune= mus_asian;
	if(rand_music eq 3) next_tune= atm_gr06;
	if(rand_music eq 4) next_tune= mus_ot;
	if(rand_music eq 5) next_tune= mus_ambgrv1;
	if(rand_music eq 6) next_tune= mus_pursuit;
	if(rand_music eq 7) next_tune= mus_xtr1;
	if(rand_music eq 8) next_tune= mus_space01;
	if(rand_music eq 9) next_tune= mus_main01;
	if(rand_music eq 10) next_tune= mus_chase;
	if(rand_music eq 11) next_tune= mus_lz;
	if(rand_music eq 12) next_tune= mus_ambgrv2;
}

######## DEATH MESSAGES (LEVEL-INDEPENDENT)
func RandDead {
	if(rand_dead eq  0) dmsg "is dead"
	if(rand_dead eq  1) dmsg "is no more"
	if(rand_dead eq  2) dmsg "has ceased to be"
	if(rand_dead eq  3) dmsg "has expired"
	if(rand_dead eq  4) dmsg "is history"
	if(rand_dead eq  5) dmsg "has been neutralized"
	if(rand_dead eq  6) dmsg "has been annihilated"
	if(rand_dead eq  7) dmsg "has died"
	if(rand_dead eq  8) dmsg "has turned to dust"
	if(rand_dead eq  9) dmsg "has bitten the dust"
	if(rand_dead eq 10) dmsg "has gone"
	if(rand_dead eq 11) dmsg "will come back"
	if(rand_dead eq 12) dmsg "has been obliterated"
	if(rand_dead eq 13) dmsg "has been destroyed"
	if(rand_dead eq 14) dmsg "has been wiped out"
	if(rand_dead eq 15) dmsg "is a stiff"
	if(rand_dead eq 16) dmsg "has passed on"
	if(rand_dead eq 17) dmsg "has been destroyed"
	if(rand_dead eq 18) dmsg "is late"
	if(rand_dead eq 19) dmsg "rests in peace"
	if(rand_dead eq 20) dmsg "is bereft of life"
	if(rand_dead eq 21) dmsg "is deceased"
	if(rand_dead eq 22) dmsg "is demised"
	if(rand_dead >  22) dmsg "went bye bye"
}

func void GiveRandWeapon(string ai_name) {
	if(weaponoption eq 1) {
		fork weaponoptions();
		chr_giveweapon(ai_name, weapon_name);
	}
}


func void weaponoptions(void) {
	if (weaponoption eq 1){
		if(rand_weapon eq  0) weapon_name=  w1_tap;
		if(rand_weapon eq  1) weapon_name=  w1_tap;
		if(rand_weapon eq  2) weapon_name=  w2_sap;
		if(rand_weapon eq  3) weapon_name=  w3_phr;
		if(rand_weapon eq  4) weapon_name=  w4_psm;
		if(rand_weapon eq  5) weapon_name=  w5_sbg;
		if(rand_weapon eq  6) weapon_name=  w6_vdg;
		if(rand_weapon eq  7) weapon_name=  w7_scc;
		if(rand_weapon eq  8) weapon_name=  w8_mbo;
		if(rand_weapon eq  9) weapon_name=  w9_scr;
		if(rand_weapon eq  10) weapon_name=  w10_sni;
		if(rand_weapon eq  11) weapon_name=  w11_ba1;
	}
	if (weaponoption eq 2){
		weapon_name=  w1_tap;
	}
	if (weaponoption eq 3){
		weapon_name=  w2_sap;
	}
	if (weaponoption eq 4){
		weapon_name=  w3_phr;
	}
}



#### Utilities ####


func void options(void){
	dmsg("Select Options: [y.area] 1-danger 2-open default-cage")
	dmsg("[y.weapon] 1-random, 2-w1_tap, 3-w2_sap, 4-w3_phr")
	dmsg("Select Battle mode: AI - [y.watch] option: focus, Player - [y.fight] option: change")
	dmsg("ota # # # frag amount - area - giveweapons 1-Yes 0-No")
	}

func void killall(void){
	trigvolume_kill 1
	}


#### CHAR Script Functions ####

func void respawn(void)
{	
	if (otaflag eq 0){
		dmsg ("You lost... you failed...")
		sleep 300
		reset
	}
}

func void iron(void){
	chr_inv_reset irondemon
	sleep 10
	chr_giveweapon irondemon w45_ID2
	chr_boss_shield irondemon
}


func void snip(void){
	chr_inv_reset sniper
	sleep 20
	chr_giveweapon sniper w8_mbo
}


func void gd1w(void){
	chr_inv_reset guarddog1
	sleep 20
	chr_giveweapon guarddog1 w51_GD
}


func void gd2w(void){
	chr_inv_reset guarddog2
	sleep 20
	chr_giveweapon guarddog2 w52_GD
}


func void gd3w(void){
	chr_inv_reset guarddog3
	sleep 20
	chr_giveweapon guarddog3 w53_GD
}

func void gd4w(void){
	chr_inv_reset guarddog4
	sleep 20
	chr_giveweapon guarddog4 w54_GD
}


func void sdw(void){
	chr_inv_reset sentry
	sleep 20
	chr_giveweapon sentry w50_SD
}


func void onlyfists(void){
	chr_inv_reset rayman
	chr_inv_reset hammer
	chr_inv_reset jestergiant
	chr_inv_reset mutantmuro
}


func void count_spawn(void){	
}


func void count_death(void){
}

		
		
		
		
		

		
		
		
		
				
		
		
	
		
		
		
		
		
		
		
		
			
		
		

		
	

	
